var timerInterval = null;

function startTimer()
{
	if ( timerInterval != null )
	{
		clearInterval( timerInterval );
		timerInterval = null;
	}

	timerInterval = setInterval("updateTime(true);", 1000);
}
	
function clockLoaded()
{
	startTimer();
	fillTimeSelect();
	document.getElementById('beatsInputText').innerHTML = getLocalizedString('beats') + ':';
	document.getElementById('selectTimeText').innerHTML = getLocalizedString('time') + ':';
}

function fillTimeSelect()
{
	var selectHour = document.getElementById('selectHour');
	var selectMinute = document.getElementById('selectMinute');
	for (var i = 0; i <= 59; i++)
	{
		var text = i < 10 ? '0'+i : i;
		if (i <= 24)
		{
			selectHour.options[selectHour.options.length] = new Option(text, i);
		}
		selectMinute.options[selectMinute.options.length] = new Option(text, i);
	}
}

function getBeat()
{
	var now = new Date();
	var off = (now.getTimezoneOffset() + 60) * 60;
	var theSeconds = (now.getHours() * 3600) + (now.getMinutes() * 60) + now.getSeconds() + off;
	var beat = Math.floor(theSeconds / 86.4);
	if (beat > 1000) beat -= 1000;
	if (beat < 0) beat += 1000;
	return beat;
}

function convertToTime()
{
	var beats = document.getElementById('beatsInput').value;
	if (isNaN(beats))
	{
		document.getElementById('beatsInput').value = document.getElementById('beatsInputBackup').value;
	}
	else
	{
		var t = new Date((beats * 86.4 * 1000));
		var hours = t.getHours();
		var minutes = t.getMinutes();
		document.getElementById('selectHour').selectedIndex = hours;
		document.getElementById('selectMinute').selectedIndex = minutes;
		document.getElementById('beatsInputBackup').value = beats;
	}
}

function convertToBeat()
{
	var now = new Date();
	var off = (now.getTimezoneOffset() + 60) * 60;
	var theSeconds = (document.getElementById('selectHour').selectedIndex * 3600) + (document.getElementById('selectMinute').selectedIndex * 60) + 0 + off;
	var beat = Math.floor(theSeconds / 86.4);
	if (beat > 1000) beat -= 1000;
	if (beat < 0) beat += 1000;
	beat = beat < 10 ? '0'+beat : beat;
	beat = beat < 100 ? '0'+beat : beat;
	document.getElementById('beatsInput').value = beat;
	document.getElementById('beatsInputBackup').value = beat;
}

function updateTime()
{
	var beat = String(getBeat());
	var first = beat.substr(0, 1);
	var second = beat.substr(1, 1);
	var third = beat.substr(2, 1);
	document.getElementById('first').src = 'Images/'+first+'.png';
	document.getElementById('second').src = 'Images/'+second+'.png';
	document.getElementById('third').src = 'Images/'+third+'.png';
}

function getLocalizedString (key)
{
	try {
		return localizedStrings[key];
	} catch (ex) {}

	return key;
}

function onshow ()
{
	if (timerInterval == null)
	{
		startTimer();
	}
}

function onhide ()
{
	if (timerInterval != null)
	{
		// clear the timer
		clearInterval(timerInterval);
		timerInterval = null;
	}
}
		
//
// FLIPPER
//
		
function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function showbackside(event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("behind");

	if (window.widget)
	{
		widget.prepareForTransition("ToBack");
	}
	
	onhide();

	front.style.display = "none";
	back.style.display = "block";

	if (window.widget)
	{
		setTimeout ('widget.performTransition();', 0);
	}

	document.getElementById('fliprollie').style.display = 'none';
}

function doneClicked()
{
	var front = document.getElementById("front");
	var back = document.getElementById("behind");

	if (window.widget)
	{
		widget.prepareForTransition("ToFront");
	}

	front.style.display = "block";
	back.style.display = "none";

	setTimeout ('flipitback();', 0);
	onshow();
}

function flipitback()
{
	updateTime();
	if (window.widget)
	{
		setTimeout("widget.performTransition();", 0);
	}
}

if (window.widget) {
	widget.onhide = onhide;
	widget.onshow = onshow;
}

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};


//  Returns val if min < val < max
//  Returns min if val <= min
//  Returns max if val >= max

function limit_3 (val, min, max)
{
    return val < min ? min : (val > max ? max : val);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
}

function mousemove (event)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function clickOnProvider(event)
{
    widget.openURL(getLocalizedString('ProviderURL'));
}